unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls;

type
  TMainForm = class(TForm)
    ProgressBar1: TProgressBar;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    SaveDialog1: TSaveDialog;
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

const cmdStop=1;
const cmdRead=2;
const cmdData=3;
const cmdGetParam=4;
const cmdParam=5;

implementation

{$R *.DFM}

uses D2XXUnit,Math;

var Pole:array of byte;

function IEEE754_32ToReal(n1,n2,n3,n4:byte):real;
var Minus:boolean;
    Exponent,i,w:integer;
    Mantisa:extended;
begin
  Minus:=n4 and 128=128;
  Exponent:=((n4 and $7F)shl 1)or(n3 shr 7)-127;
  w:=((n3 and $7F) shl 16)or(n2 shl 8)or n1;
  Mantisa:=0;
  for i:=22 downto 0 do
    if w and (1 shl i)<>0 then Mantisa:=Mantisa+1/(1 shl (23-i));
  Mantisa:=Mantisa+1;
  if Minus then Mantisa:=-Mantisa;
  Result:=IntPower(2,Exponent)*Mantisa;
end;

procedure TMainForm.BitBtn4Click(Sender: TObject);
var f:integer;
    FT_Device:integer;
begin
  if(FT_Handle<>0) then
  begin
    Close_USB_Device;
  end;
  if GetFTDeviceCount<>FT_OK then exit;
  for f:=0 to FT_Device_Count-1 do
  begin
    if GetFTDeviceDescription(f)<>FT_OK then exit;
    if copy(FT_Device_String,1,20)='Vario 2007' then
    begin
      if GetFTDeviceLocation(f)<>FT_OK then exit;
      FT_Device:=FT_Device_Location;
      Open_USB_Device_By_Device_Location(FT_Device);
      FT_Current_Baud:=FT_BAUD_57600;
      FT_Current_DataBits:=FT_DATA_BITS_8;
      FT_Current_StopBits:=FT_STOP_BITS_1;
      FT_Current_Parity:=FT_PARITY_NONE;
      FT_Current_FlowControl:=FT_FLOW_NONE;
      Set_USB_Device_BaudRate;
      Set_USB_Device_DataCharacteristics;
      Set_USB_Device_FlowControl;
      Set_USB_Device_TimeOuts(100,0);
      exit;
    end;
  end;
  MessageDlg('Chyba - Vario 2007 reader nenalezen'#13#10'Zkuste opojit a pipojit zazen',mtError,[mbAbort],0);
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
var Prikaz:byte;
    EESize,Pozice,Readed:integer;
begin
  BitBtn4Click(Sender);
  if FT_Handle=0 then exit;
  SetLength(Pole,0);
  Purge_USB_Device_In;
  Purge_USB_Device_Out;
  Prikaz:=cmdRead;
  USBWrite(Prikaz,1);
  ProgressBar1.Position:=0;
  USBRead(Prikaz,1);
  if Prikaz<>cmdData then
  begin
    MessageDlg('Vario neodpovd'#13#10'Doporuuji vypnout a zapnout'#13#10'Nebo je vybit baterka',
               mtWarning,[mbAbort],0); 
    exit;
  end;
  USBRead(Prikaz,1);
  EESize:=($1000 shl Prikaz)-1;
  ProgressBar1.Max:=EESize;
  SetLength(Pole,EESize);
  FillChar(Pole[0],EESize,$FF);
  Pozice:=0;
  Application.ProcessMessages;
  repeat
    Readed:=Read_USB_Device_Buffer(EESize-Pozice);
    Move(FT_In_Buffer[0],Pole[Pozice],Readed);
    Pozice:=Pozice+Readed;
    Sleep(1);
    ProgressBar1.Position:=Pozice;
    Application.ProcessMessages;
  until (Pozice>=EESize)or(Readed=0);
  ProgressBar1.Position:=0;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if(FT_Handle<>0) then
  begin
    Close_USB_Device;
  end;
end;

procedure TMainForm.BitBtn2Click(Sender: TObject);
var Soubor:TextFile;
    Pozice,Let,Vyska:integer;
    Soubor2:file;
    Tlak:real;
begin
  if Length(Pole)=0 then exit;
  SaveDialog1.FileName:=FormatDateTime('yyyy-mm-dd',Date)+'.txt';
  if SaveDialog1.Execute then
  begin
    if SaveDialog1.FilterIndex=1 then
    begin
      SaveDialog1.FileName:=ChangeFileExt(SaveDialog1.FileName,'.txt');
      try
        AssignFile(Soubor,SaveDialog1.FileName);Rewrite(Soubor);
        Pozice:=0;
        Let:=1;
        while Pozice+1+10<Length(Pole) do
        begin
          // FEFF
          while (Pozice+1+10<Length(Pole))and(Pole[Pozice]<>$FE)and(Pole[Pozice+1]<>$FF) do inc(Pozice,2);
          // FEFF + Adresa
          inc(Pozice,4);
          Tlak:=IEEE754_32ToReal(Pole[Pozice],Pole[Pozice+1],Pole[Pozice+2],Pole[Pozice+3]);
          inc(Pozice,4);
          Vyska:=Pole[Pozice] or (Pole[Pozice+1] shl 8);
          inc(Pozice,2);
          WriteLn(Soubor,'Let '+IntToStr(Let));inc(Let);
          WriteLn(Soubor,'Pepoten tlak na hladinu moe [Pa] ',Tlak:1:2);
          WriteLn(Soubor,'Vka kopce '+IntToStr(Vyska));
          WriteLn(Soubor,'Zpis kadch ',Pole[Pozice]/2:1:1,' sekund');
          inc(Pozice,2);
          while (Pozice+1<Length(Pole))and
                ((Pole[Pozice]<>$FF)or(Pole[Pozice+1]<>$FF))and
                ((Pole[Pozice]<>$FE)or(Pole[Pozice+1]<>$FF)) do
          begin
            Vyska:=(Pole[Pozice] or (Pole[Pozice+1] shl 8))-10000;
            WriteLn(Soubor,Vyska);
            inc(Pozice,2);
          end;
          if (Pole[Pozice]=$FF)and(Pole[Pozice+1]=$FF) then break;
        end;
      finally
        CloseFile(Soubor);
      end;
    end;
    if SaveDialog1.FilterIndex=2 then
    begin
      SaveDialog1.FileName:=ChangeFileExt(SaveDialog1.FileName,'.bin');
      try
        AssignFile(Soubor2,SaveDialog1.FileName);Rewrite(Soubor2,1);
        BlockWrite(Soubor2,Pole[0],Length(Pole));
      finally
        CloseFile(Soubor2);
      end;
    end;
  end;
end;

end.
