//#define OscFrq      9216000*4

// Adresy I2C zazen

#define SAA1064	0x70
#define MCP23016	0x40
#define I2CEEPROM	0xA0
#define TDA8444   0x40
#define PCF8583   0xA2

#define SmallEEPROM     1
#define BigEEPROM       2
#define I2CEEPROMType   BigEEPROM

// Definice pro display s SAA1064

#define Seg7_0	0b00111111
#define Seg7_1	0b00000110
#define Seg7_2	0b01011011
#define Seg7_3	0b01001111
#define Seg7_4	0b01100110
#define Seg7_5	0b01101101
#define Seg7_6	0b01111101
#define Seg7_7	0b00000111
#define Seg7_8	0b01111111
#define Seg7_9	0b01101111

#define Seg7_A	0b01110111
#define Seg7_b	0b01111100
#define Seg7_c	0b01011000
#define Seg7_C	0b00111001
#define Seg7_d	0b01011110
#define Seg7_E	0b01111001
#define Seg7_F	0b01110001
#define Seg7_g	0b01101111
#define Seg7_h	0b01110100
#define Seg7_H	0b01110110
#define Seg7_i	0b00000100
#define Seg7_J	0b00011110
#define Seg7_L	0b00111000
#define Seg7_M	0b00110111
#define Seg7_n	0b01010100
#define Seg7_o	0b01011100
#define Seg7_P	0b01110011
#define Seg7_q	0b01100111
#define Seg7_r	0b01010000
#define Seg7_S	0b01101101
#define Seg7_t	0b01111000
#define Seg7_u	0b00011100
#define Seg7_U	0b00111110
#define Seg7_Y	0b01110010
#define Seg7_Z	0b01011011

#define Seg7_minus	0b01000000
#define Seg7_mriz		0b01001001
#define Seg7_podtrzitko	0b00001000
#define Seg7_nic		0b00000000
#define Seg7_space	0b00000000
#define Seg7_tecka	0b10000000
#define Seg7_stupnu	0b01011100

// Definice pro MCP23016 expandr I/O

#define MCP23016_GP0	0x00	// Stav vvod portu 0
#define MCP23016_GP1	0x01	// Stav vvod protu 1
#define MCP23016_OLAT0	0x02	// Vstup vvod protu 0
#define MCP23016_OLAT1	0x03	// Vstup vvod protu 1
#define MCP23016_IPOL0	0x04  // Polarita pi ten protu 0
#define MCP23016_IPOL1	0x05  // Polarita pi ten protu 1
#define MCP23016_IODIR0	0x06  // Volba smru dat (I nebo O) portu 0
#define MCP23016_IODIR1	0x07  // Volba smru dat (I nebo O) portu 1
#define MCP23016_ICAP0	0x08	// Hodnota protu 0 pi kter dolo k peruen
#define MCP23016_ICAP1	0x09	// Hodnota protu 1 pi kter dolo k peruen
#define MCP23016_IOCON0	0x0A	// Rychlost vzorkovac frekvence portu 0
#define MCP23016_IOCON1	0x0B	// Rychlost vzorkovac frekvence portu 1

// Definice pro I2C chyby sbrnice

#define I2C_sOK		0
#define I2C_sError	1
#define I2C_sNoAck	2


#ifdef SAA1064Dis
// Symboly pro SAA1064 displej
extern const Num7[];
#endif

extern bit I2CError;

// Data pro zobrazen
extern unsigned char DisplayData[4];
extern unsigned char OldMCP23016KeyVal;

extern void I2CSetup(void);
extern void I2CStart(void);
extern void I2CStop(void);
extern void I2COut(char b);
extern char I2CIn(void);
extern bit SetI2CEEPROMAdr(unsigned int EEAdr);
extern bit SetI2CEEPROMRd(unsigned int EEAdr);
extern char DeviceExists(unsigned char DevAdr);

// zen displeje s SAA1064
#ifdef SAA1064Dis
extern void SetDisplay(unsigned char Control);
extern void WriteDisplay(void);
extern void ClearDisplay(void);
extern void putsDisplay(const char * s);
#endif

// zen MCP23016
#ifdef MCPKeyboard
extern void SetupMCP23016Key64();
extern unsigned char ReadMCP23016Keyboard64(unsigned char Sloupec);
extern unsigned char GetKeyMCP23016Key64();
extern void SetupMCP23016Key60();
extern unsigned int ReadMCP23016Keyboard60(unsigned char Sloupec);
extern unsigned char GetKeyMCP23016Key60();
#endif

// Nastaven analogovho vstupu s TDA8444
#ifdef UseTDA8444
extern void SetVoltTDA8444(unsigned char Vystup, unsigned char Value);
extern void SetRangeTDA8444(unsigned char Start, unsigned char Stop, unsigned char * Values);
#endif
